/*
 * nt.c - The NT-specific code for autoext2
 *
 * Copyright (C) 1998 Andrey Shedel (andreys@tarzan.cr.cyco.com)
 *
 * %Begin-Header%
 * This file may be redistributed under the terms of the GNU Public
 * License.
 * %End-Header%
 */


//
// Standard ddk defines
//


#pragma warning(disable:4514) // unreferenced inline function has been removed
#pragma warning(push, 4)
#pragma warning(disable:4201) // nonstandard extension used : nameless struct/union)
#pragma warning(disable:4214) // nonstandard extension used : bit field types other than int
#pragma warning(disable:4115) // named type definition in parentheses

//#include <nt.h>
//#include <ntrtl.h>
#include <ntddk.h>
#include <ntdddisk.h>
#include <ntstatus.h>

#pragma warning(pop)



//
// Some missed defines.
//

NTSYSAPI
NTSTATUS
NTAPI
NtTerminateProcess(
   IN HANDLE ProcessHandle,
   IN LONG ExitStatus
   );

NTSYSAPI
PVOID
NTAPI
RtlAllocateHeap(
   IN HANDLE Heap,
   IN ULONG Flags,
   IN ULONG Size
   );

NTSYSAPI
BOOLEAN
NTAPI
RtlFreeHeap(
    IN HANDLE Heap,
    IN ULONG Flags,
    IN PVOID Address
   );

NTSYSAPI
NTSTATUS
NTAPI
NtQuerySystemTime(
    IN PLARGE_INTEGER Time
   );

NTSYSAPI
BOOLEAN
NTAPI
RtlTimeToSecondsSince1970 (
    PLARGE_INTEGER Time,
    PULONG ElapsedSeconds
    );

NTSYSAPI
VOID
NTAPI
RtlSecondsSince1970ToTime (
    ULONG ElapsedSeconds,
    PLARGE_INTEGER Time
    );

NTSYSAPI
NTSTATUS
NTAPI
NtDisplayString(
   IN PUNICODE_STRING String
  );


typedef struct _RTL_USER_PROCESS_PARAMETERS *PRTL_USER_PROCESS_PARAMETERS;


NTSYSAPI
PRTL_USER_PROCESS_PARAMETERS
NTAPI
RtlNormalizeProcessParams(
    IN PRTL_USER_PROCESS_PARAMETERS ProcessParameters
   );


typedef struct _PEB_LDR_DATA *PPEB_LDR_DATA;
typedef struct _PEB_FREE_BLOCK *PPEB_FREE_BLOCK;
typedef struct _PEB *PPEB;



typedef struct _CURDIR {
	UNICODE_STRING DosPath; //0
	HANDLE Handle; //8
}CURDIR;//0x0c


typedef struct _RTL_DRIVE_LETTER_CURDIR {
	USHORT Flags;//0
	USHORT Length;//2
	ULONG TimeStamp;//4
	STRING  DosPath; //8
}RTL_DRIVE_LETTER_CURDIR; //0x10


typedef struct _PEB {

	BOOLEAN Inheritedaddressspace;//0
	BOOLEAN ReadImageFileExecOptions;//1
	BOOLEAN BeingDebugged;//2
	BOOLEAN SpareBool;//3

	HANDLE Mutant;//4

	PVOID ImageBaseAddress;//8

	PPEB_LDR_DATA Ldr;//0x0c
	PRTL_USER_PROCESS_PARAMETERS ProcessParameters;//0x10

	PVOID SubSystemData;//0x14

	PVOID ProcessHeap;//0x18

	PVOID FastPebLock;//0x1c
	PVOID FastPebLockRoutine;//0x20
	PVOID FastPebUnlockRoutine;//0x24

	ULONG EnvironmentUpdateCount;//0x28
	PVOID KernelCallbackTable;//0x2c

	HANDLE EventLogSection;//0x30
	PVOID EventLog;//0x34

	PPEB_FREE_BLOCK FreeList;//0x38

	ULONG TlsExpansionCounter;//0x3c
	PVOID TlsBitmap;//0x40
	ULONG TlsBitMapBits;//0x44
	ULONG Spare0;

	PVOID ReadOnlySharedMemoryBase;//0x4c
	PVOID ReadOnlySharedMemoryHeap;//0x50
	PVOID ReadOnlyStaticServerData;//0x54

	PVOID AnsiCodePageData;//0x58
	PVOID OemCodePageData;//0x5c
	PVOID UnicodeCaseTableData;//0x60

	ULONG NumberOfProcessors;//0x64
	ULONG NtGlobalFlag;//0x68
	ULONG Spare1;
	LARGE_INTEGER CriticalSectionTimeout;//0x70
	ULONG HeapSegmentReserve;//0x78
	ULONG HeapSegmantCommit;//0x7c
	ULONG HeapDeCommitTotalFreeThreshold;//0x80
	ULONG HeapDeCommitFreeBlockThreshold;//0x84

	ULONG NumberOfHeaps;//0x88
	ULONG MaximumNumberOfHeaps;//0x8c
	PVOID ProcessHeaps;//0x90
	PVOID GdiSharedHandleTable;//0x94
	PVOID ProcessStarterHelper;//0x98
	PVOID GdiDCAttributeList;//0x9c

	PVOID LoaderLock;//0xa0

	ULONG OSMajorVersion;//0xa4
	ULONG OSMinorVersion;//0xa8
	ULONG OSBuildNumber;//0xac
	ULONG OSPlatformId;//0xb0
	ULONG ImageSubsystem;//0xb4
	ULONG ImageSubsystemMajorVersion;//0xb8
	ULONG ImageSubsystemMinorVersion;//0xbc
	ULONG ImageProcessAffinityMask;//0xc0

	ULONG GdiHandleBuffer[30];//0xc4

} PEB; //0x50





typedef struct _RTL_USER_PROCESS_PARAMETERS {

	ULONG MaximumLength;//0
	ULONG Length;//4

	ULONG Flags;//8
	ULONG DebugFlags;//0x0c

	HANDLE ConsoleHandle;//0x10
	ULONG ConsoleFlags;//0x14

	HANDLE StandardInput;//0x18
	HANDLE StandardOutput;//0x1c
	HANDLE StandardError;//0x20

	CURDIR CurrentDirectory;//0x24

	UNICODE_STRING DllPath;//0x30
	UNICODE_STRING ImagePathName;//0x38
	UNICODE_STRING CommandLine;//0x40
	PWSTR Environment;//0x48

	ULONG StartingX;//0x4c
	ULONG StartingY;//0x50
	ULONG CountX;//0x54
	ULONG CountY;//0x58
	ULONG CountCharsX;//0x5c
	ULONG CountCharsY;//0x60

	ULONG FileAttribute;//0x64

	ULONG WindowFlags;//0x68
	ULONG ShowWindowFlags;//0x6c
	UNICODE_STRING  WindowTitle;//0x70
	UNICODE_STRING DesktopInfo;//0x78
	UNICODE_STRING ShellInfo;//0x80
	UNICODE_STRING RuntimeData;//0x88
	RTL_DRIVE_LETTER_CURDIR CurrentDirectores[0x20];//0x90

}RTL_USER_PROCESS_PARAMETERS;









static HANDLE _ProcessHeap = NULL;

#define RtlProcessHeap() _ProcessHeap

int _stderror = -2;


#include <stdlib.h>
#include <malloc.h>
#include <stdio.h>
#include <time.h>
#include <stdarg.h>
#include <errno.h>


FILE _iob[3];


static int __errno = 0;

int * __cdecl _errno(void)
{
	return &__errno;
}

__declspec(noreturn) void __cdecl exit(int code)
{
	NtTerminateProcess(NtCurrentProcess(), code);
	*(PULONG)1 = 0;
}

void * __cdecl realloc(void *p, size_t size)
{
	void* p1 = malloc(size);

	if(NULL == p1)
		return NULL;

	if(NULL != p)
		RtlCopyMemory(p1, p, size);

	return p1;
}

void * __cdecl malloc(size_t size)
{
	return RtlAllocateHeap(RtlProcessHeap(), 0, size);
}

void   __cdecl free(void * p)
{
	RtlFreeHeap(RtlProcessHeap(), 0, p);
}


/*char * __cdecl getenv(const char * env)
{
	return NULL;
}
 */


int __cdecl _write(int fd, const void *p, unsigned int c)
{
	return 0;
}

void __cdecl setbuf(FILE *fd, char *p)
{
}




char *_sys_errlist[] =
{
    /*  0              */  "No error",
    /*  1 EPERM        */  "Operation not permitted",
    /*  2 ENOENT       */  "No such file or directory",
    /*  3 ESRCH        */  "No such process",
    /*  4 EINTR        */  "Interrupted function call",
    /*  5 EIO          */  "Input/output error",
    /*  6 ENXIO        */  "No such device or address",
    /*  7 E2BIG        */  "Arg list too long",
    /*  8 ENOEXEC      */  "Exec format error",
    /*  9 EBADF        */  "Bad file descriptor",
    /* 10 ECHILD       */  "No child processes",
    /* 11 EAGAIN       */  "Resource temporarily unavailable",
    /* 12 ENOMEM       */  "Not enough space",
    /* 13 EACCES       */  "Permission denied",
    /* 14 EFAULT       */  "Bad address",
    /* 15 ENOTBLK      */  "Unknown error",                     /* not POSIX */
    /* 16 EBUSY        */  "Resource device",
    /* 17 EEXIST       */  "File exists",
    /* 18 EXDEV        */  "Improper link",
    /* 19 ENODEV       */  "No such device",
    /* 20 ENOTDIR      */  "Not a directory",
    /* 21 EISDIR       */  "Is a directory",
    /* 22 EINVAL       */  "Invalid argument",
    /* 23 ENFILE       */  "Too many open files in system",
    /* 24 EMFILE       */  "Too many open files",
    /* 25 ENOTTY       */  "Inappropriate I/O control operation",
    /* 26 ETXTBSY      */  "Unknown error",                     /* not POSIX */
    /* 27 EFBIG        */  "File too large",
    /* 28 ENOSPC       */  "No space left on device",
    /* 29 ESPIPE       */  "Invalid seek",
    /* 30 EROFS        */  "Read-only file system",
    /* 31 EMLINK       */  "Too many links",
    /* 32 EPIPE        */  "Broken pipe",
    /* 33 EDOM         */  "Domain error",
    /* 34 ERANGE       */  "Result too large",
    /* 35 EUCLEAN      */  "Unknown error",                     /* not POSIX */
    /* 36 EDEADLK      */  "Resource deadlock avoided",
    /* 37 UNKNOWN      */  "Unknown error",
    /* 38 ENAMETOOLONG */  "Filename too long",
    /* 39 ENOLCK       */  "No locks available",
    /* 40 ENOSYS       */  "Function not implemented",
    /* 41 ENOTEMPTY    */  "Directory not empty",
    /* 42 EILSEQ       */  "Illegal byte sequence",
    /* 43              */  "Unknown error"

};


#define _SYS_MSGMAX 38
#define _ERRMSGLEN_ _SYS_MSGMAX + 2
int _sys_nerr = sizeof( _sys_errlist ) / sizeof( _sys_errlist[ 0 ] ) - 1;

#define _sys_err_msg(m) _sys_errlist[(((m)<0)||((m)>=_sys_nerr)?_sys_nerr:(m))]

char * __cdecl strerror (int errnum)
{
	static char errmsg[_ERRMSGLEN_];  /* Longest errmsg + \0 */
	strcpy(errmsg, _sys_err_msg(errnum));
	return errmsg;
}


int __cdecl isatty(int fd)
{
	return 0;
}


time_t __cdecl time(time_t *t)
{
	time_t rv;
	LARGE_INTEGER Time;

	NtQuerySystemTime(&Time);
	RtlTimeToSecondsSince1970(&Time, &rv);

	if(NULL != t)
		*t = rv;

	return rv;
}

int __cdecl fflush(FILE *fd)
{
	return 0;
}




FILE * __cdecl fopen(const char *name, const char *mode)
{
	errno = ENOENT;
	return NULL;
}

int __cdecl fclose(FILE *fd)
{
	return 0;
}

FILE * __cdecl _popen(const char *name, const char *mode)
{
	errno = ENOENT;
	return NULL;
}


int __cdecl _pclose(FILE *fd)
{
	return 0;
}


int __cdecl vprintf(const char *f, va_list v)
{
	char buffer[2048];
	ANSI_STRING AnsiString;
	UNICODE_STRING UnicodeString;
	WCHAR Buffer[sizeof(buffer)];


	_vsnprintf(buffer, sizeof(buffer), f, v);

	DbgPrint(buffer);

	RtlInitAnsiString(&AnsiString, buffer);

	UnicodeString.Buffer = Buffer;
	UnicodeString.Length = 0;
	UnicodeString.MaximumLength = sizeof(Buffer);// in bytes

	RtlAnsiStringToUnicodeString(&UnicodeString, &AnsiString, FALSE);


	NtDisplayString(&UnicodeString);


	return 0;
}

int __cdecl printf(const char *format, ...)
{
	va_list arglist;
	va_start(arglist, format);
	return vprintf(format, arglist);
}

int __cdecl vfprintf(FILE *fd, const char *f, va_list l)
{
	return vprintf(f, l);
}


int __cdecl fputs(const char *f, FILE *fd)
{
	return printf(f);
}

char * __cdecl fgets(char *s, int c, FILE *fd)
{
	return NULL;
}

int __cdecl fputc(int c, FILE *fd)
{
	char b[2];
	b[0] = c;
	b[2] = '\0';

	return fputs(b, fd);
}



int __cdecl putc(int c, FILE *fd)
{
	return fputc(c, fd);
}


int __cdecl getch(void)
{
	return 'y';
}



int __cdecl fprintf(FILE *fd, const char *format, ...)
{
	va_list arglist;
	va_start(arglist, format);
	return vprintf(format, arglist);
}


static char* __cdecl store_dt(char* p, int val)
{
	*p++ = (char)('0' + val / 10);
	*p++ = (char)('0' + val % 10);

	return p;
}

const char __dnames[] = {
        "SunMonTueWedThuFriSat"
};

const char __mnames[] = {
        "JanFebMarAprMayJunJulAugSepOctNovDec"
};

char * __cdecl ctime(const time_t * t)
{
	char* p;
	int i;
	static char timebuf[26];
	TIME_FIELDS Fields;
	LARGE_INTEGER Time;

	ASSERT(NULL != t);

	RtlSecondsSince1970ToTime(*t, &Time);
	RtlTimeToTimeFields(&Time, &Fields);

	p = timebuf;


	//
	// copy day and month names into the buffer
	//

	for (i=0; i < 3; i++,p++)
	{
		*p = *(__dnames + Fields.Day - 1 + i);
		*(p+4) = *(__mnames + Fields.Month - 1 + i);
	}

	//
	// blank between day and month
	//

	*p = ' ';

	p += 4;

	*p++ = ' ';
	p = store_dt(p, Fields.Day);   /* day of the month (1-31) */
	*p++ = ' ';
	p = store_dt(p, Fields.Hour);   /* hours (0-23) */
	*p++ = ':';
	p = store_dt(p, Fields.Minute);    /* minutes (0-59) */
	*p++ = ':';
	p = store_dt(p, Fields.Second);    /* seconds (0-59) */
	*p++ = ' ';
	p = store_dt(p, 19 + (Fields.Year / 100)); /* year (after 1900) */
	p = store_dt(p, Fields.Year % 100);
	*p++ = '\n';
	*p = '\0';

	return timebuf;
}

/*
void _chkesp(void)
{
}
*/


//////////////// buggy part of NT CRT


extern
int
__cdecl
main();




VOID
__stdcall
NtProcessStartup(
    IN PPEB Peb
	)
{
	int    argc = 0;
	char** argv = NULL;
	char** envp = NULL;

	char** argvp;
	char* ps;
	char* pd;

	PRTL_USER_PROCESS_PARAMETERS ProcessParameters;
	int InitialBreakpoint = FALSE;
	ANSI_STRING AnsiString;


	ProcessParameters = RtlNormalizeProcessParams(Peb->ProcessParameters);

	_ProcessHeap = Peb->ProcessHeap;

	if(NULL != ProcessParameters)
	{
		InitialBreakpoint = ProcessParameters->DebugFlags;

		argvp = argv = RtlAllocateHeap(Peb->ProcessHeap, 0, 2048);

		*argvp = NULL;

		//
		// Use command line if given. If not use image file name.
		//

		if((NULL != ProcessParameters->CommandLine.Buffer) &&
		   (L'\0' != *(ProcessParameters->CommandLine.Buffer)))
		{
			RtlUnicodeStringToAnsiString(
										 &AnsiString,
										 &ProcessParameters->CommandLine,
										 TRUE
										);
		}
		else
		{
			RtlUnicodeStringToAnsiString(
										 &AnsiString,
										 &ProcessParameters->ImagePathName,
										 TRUE
										);
		}

		//
		// Convert argv counting argc
		//

		if(NULL != AnsiString.Buffer)
		{

			ps = AnsiString.Buffer;

			//
			// Allocate buffer.
			//

			pd = RtlAllocateHeap(Peb->ProcessHeap, 0, AnsiString.Length + 2);


			while('\0' != *ps)
			{
				//
				// Skip spaces.
				//

				while((*ps <= ' ') && ('\0' != *(++ps)))
					;

				//
				// Add if non-empty.
				//

				if('\0' != *ps)
				{
					++argc;
					*(argvp++) = pd;

					//
					// Copy
					//

					while(*ps > ' ')
						*(pd++) = *(ps++);

					//
					// Zero-terminate
					//

					*(pd++) = '\0';
				}
			}
		}

		//
		// Convert environment
		//

		*(argvp++) = NULL;

		//
		// Use rest as environment buffer.
		// b2b compatible ;).
		//

		envp = argvp;

		ps = (char*)(ProcessParameters->Environment);

		if(NULL != ps)
		{
			while('\0' != *ps)
			{
				*(argvp++) = ps;

				while('\0' != *(ps++))
					;
			}
		}

		*argvp = NULL;
	}


	if(InitialBreakpoint)
		DbgBreakPoint();


	NtTerminateProcess(NtCurrentProcess(), main(argc, argv, envp, InitialBreakpoint));
	*(PULONG)1 = 0;
}



