/*
 * nt.c - The NT-specific code for ext2lib
 *
 * %Begin-Header%
 * This file may be redistributed under the terms of the GNU Public
 * License.
 * %End-Header%
 */


#pragma warning(disable:4514) // unreferenced inline function has been removed
#pragma warning(push, 4)
#pragma warning(disable:4201) // nonstandard extension used : nameless struct/union)

#pragma warning(disable:4214) // nonstandard extension used : bit field types other than int
#pragma warning(disable:4115) // named type definition in parentheses

//#include <nt.h>
//#include <ntrtl.h>
#include <ntddk.h>


#pragma warning(pop)



#include <stdlib.h>
#include <malloc.h>
#include <stdio.h>
#include <time.h>
#include <stdarg.h>
#include <errno.h>




#ifdef EXT2_NATIVE


char *_sys_errlist[] =
{
    /*  0              */  "No error",
    /*  1 EPERM        */  "Operation not permitted",
    /*  2 ENOENT       */  "No such file or directory",
    /*  3 ESRCH        */  "No such process",
    /*  4 EINTR        */  "Interrupted function call",
    /*  5 EIO          */  "Input/output error",
    /*  6 ENXIO        */  "No such device or address",
    /*  7 E2BIG        */  "Arg list too long",
    /*  8 ENOEXEC      */  "Exec format error",
    /*  9 EBADF        */  "Bad file descriptor",
    /* 10 ECHILD       */  "No child processes",
    /* 11 EAGAIN       */  "Resource temporarily unavailable",
    /* 12 ENOMEM       */  "Not enough space",
    /* 13 EACCES       */  "Permission denied",
    /* 14 EFAULT       */  "Bad address",
    /* 15 ENOTBLK      */  "Unknown error",                     /* not POSIX */
    /* 16 EBUSY        */  "Resource device",
    /* 17 EEXIST       */  "File exists",
    /* 18 EXDEV        */  "Improper link",
    /* 19 ENODEV       */  "No such device",
    /* 20 ENOTDIR      */  "Not a directory",
    /* 21 EISDIR       */  "Is a directory",
    /* 22 EINVAL       */  "Invalid argument",
    /* 23 ENFILE       */  "Too many open files in system",
    /* 24 EMFILE       */  "Too many open files",
    /* 25 ENOTTY       */  "Inappropriate I/O control operation",
    /* 26 ETXTBSY      */  "Unknown error",                     /* not POSIX */
    /* 27 EFBIG        */  "File too large",
    /* 28 ENOSPC       */  "No space left on device",
    /* 29 ESPIPE       */  "Invalid seek",
    /* 30 EROFS        */  "Read-only file system",
    /* 31 EMLINK       */  "Too many links",
    /* 32 EPIPE        */  "Broken pipe",
    /* 33 EDOM         */  "Domain error",
    /* 34 ERANGE       */  "Result too large",
    /* 35 EUCLEAN      */  "Unknown error",                     /* not POSIX */
    /* 36 EDEADLK      */  "Resource deadlock avoided",
    /* 37 UNKNOWN      */  "Unknown error",
    /* 38 ENAMETOOLONG */  "Filename too long",
    /* 39 ENOLCK       */  "No locks available",
    /* 40 ENOSYS       */  "Function not implemented",
    /* 41 ENOTEMPTY    */  "Directory not empty",
    /* 42 EILSEQ       */  "Illegal byte sequence",
    /* 43              */  "Unknown error"

};


#define _SYS_MSGMAX 38
#define _ERRMSGLEN_ _SYS_MSGMAX + 2
int _sys_nerr = sizeof( _sys_errlist ) / sizeof( _sys_errlist[ 0 ] ) - 1;

#define _sys_err_msg(m) _sys_errlist[(((m)<0)||((m)>=_sys_nerr)?_sys_nerr:(m))]

char * __cdecl strerror (int errnum)
{
	static char errmsg[_ERRMSGLEN_];  /* Longest errmsg + \0 */
	strcpy(errmsg, _sys_err_msg(errnum));
	return errmsg;
}



time_t __cdecl time(time_t *t)
{
	time_t rv;
	LARGE_INTEGER Time;

	NtQuerySystemTime(&Time);
	RtlTimeToSecondsSince1970(&Time, &rv);

	if(NULL != t)
		*t = rv;

	return rv;
}




static char* __cdecl store_dt(char* p, int val)
{
	*p++ = (char)('0' + val / 10);
	*p++ = (char)('0' + val % 10);

	return p;
}

const char __dnames[] = {
        "SunMonTueWedThuFriSat"
};

const char __mnames[] = {
        "JanFebMarAprMayJunJulAugSepOctNovDec"
};



char * __cdecl ctime(const time_t * t)
{
	char* p;
	int i;
	static char timebuf[26];
	TIME_FIELDS Fields;
	LARGE_INTEGER Time;

	ASSERT(NULL != t);

	RtlSecondsSince1970ToTime(*t, &Time);
	RtlTimeToTimeFields(&Time, &Fields);

	p = timebuf;


	//
	// copy day and month names into the buffer
	//

	for (i=0; i < 3; i++,p++)
	{
		*p = *(__dnames + Fields.Day - 1 + i);
		*(p+4) = *(__mnames + Fields.Month - 1 + i);
	}

	//
	// blank between day and month
	//

	*p = ' ';

	p += 4;

	*p++ = ' ';
	p = store_dt(p, Fields.Day);   /* day of the month (1-31) */
	*p++ = ' ';
	p = store_dt(p, Fields.Hour);   /* hours (0-23) */
	*p++ = ':';
	p = store_dt(p, Fields.Minute);    /* minutes (0-59) */
	*p++ = ':';
	p = store_dt(p, Fields.Second);    /* seconds (0-59) */
	*p++ = ' ';
	p = store_dt(p, 19 + (Fields.Year / 100)); /* year (after 1900) */
	p = store_dt(p, Fields.Year % 100);
	*p++ = '\n';
	*p = '\0';

	return timebuf;
}


#endif EXT2_NATIVE


